#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_reduce_method4xi.py">
#<abstract4xi abstract = "providing function _reduce_method4xi"/>
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_reduce_method4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # winapi
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import forking
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>




# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce-method4xi" usage = "
#     forking.py 
#         ForkingPickler.register(type(_C().f), _reduce_method)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------        
def _reduce_method4xi(m):
    '''
    reduces method
    '''
        
    # -----------------------------------------------------------------------------------------    
    # (Step 1/2) 
    # -----------------------------------------------------------------------------------------        
       
    class2print = "_reduce_method4xi"
    method2print = "_reduce_method4xi"
    
    message2print = "{(Step 1/2a) started" + "; reduce-method4xi-started: " + str(_reduce_method4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
       
    message2print = "{(Step 1/2b) passed" + "; method-passed-to-reduce-method4xi: " + str(m) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
   
    
    if m.__self__ is None:
        
        # -------------------------------------------------------------------------------------    
        # (Step 2/2a) 
        # -------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2a1) passing" + "; method-class-passing-to-getattr-by-reduce-method4xi: " + str(m.__class__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{(Step 2/2a2) passing" + "; function-name-passing-to-getattr-by-reduce-method4xi: " + str(func__.__name__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
       
        message2print = "{(Step 2/2a3) returning" + "; getattr-function-returning-by-reduce-method4xi: " + str(getattr) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                
        return getattr, (m.__class__, m.__func__.__name__)
    else:

        
        # -------------------------------------------------------------------------------------    
        # (Step 2/2b) 
        # -------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2b1) passing" + "; method-pointer-passing-to-getattr-by-reduce-method4xi: " + str(m.__self__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{(Step 2/2b2) passing" + "; method-function-name--passing-to-getattr-by-reduce-method4xi: " + str(m.__func__.__name__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
       
        message2print = "{(Step 2/2b3) returning" + "; getattr-function-returning-by-reduce-method4xi: " + str(getattr) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
               

        return getattr, (m.__self__, m.__func__.__name__)

#</function4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_reduce_method4xi.txt
#   sense-test-reduce-method4xi.xml
#   reason-test-reduce-method4xi.xml
#   ace-test-reduce-method4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _reduce_method4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

